
;**********************************************************
;*** Comptage des impulsions issues dcodeur incrmental ***
;**********************************************************

;**********************************************************
;*** Signal TOP arret moteur du capteur 1 sur le port RB2
;*** Signal TOP arret moteur du capteur 2 sur le port RB3
;*** Entre capteur 1 ==> RB0
;*** Entre capteur 2 ==> RB1
;**********************************************************
comptage
	bcf	PORTB,2
	bcf	PORTB,3
	bcf	PORTB,5
	clrf	Compter_par_pas_9
	clrf	Compter_par_pas_10

	movlw	0X004
	movwf	pas_incremental

	;**************************
	;*** DEBUT du comptage
	;**************************
	Call	comptage_capt
	;***************************
	;*** FIN Du Comptage
	;***************************	

	bcf	PORTB,4	;!!! pour debug !!!
	
	bcf	STATUS,Z
	bsf	PORTB,5
	call	ENVOI_FIN_ASSERVISSEMENT
fin_comptage
	bcf	STATUS,Z
	bcf	STATUS,C
	bcf	PORTB,2
	bcf	PORTB,3
	return

;*******************
;*** Capteurs : moteur e/s 9 et e/s 10
;*******************
comptage_capt
	
	movf	compter_capt1,W	;*** compter_Capt1: octet de poids fort
	movwf	Compter_9_Octet_high

	movf	compter_capt1,W	;*** compter_Capt1: octet de poids fort
	movwf	Compter_10_Octet_high

bcle_comptage_capt

	;******************************************************
	;*** Appel diffrence trop grande entre les 2 comptages
	;******************************************************
	;!!! pour DEBUG
	btfsc PORTA,1
	bsf PORTB,4
	;!!! pour DEBUG
	btfsc PORTA,1
	Call difference_trop_grande

	btfss PORTA,1
	bcf PORTB,4

	;******************************************************

	btfss	indic_comptage_termine,0	;***Comptage moteur 9
	call	Comptage_capt_mot9

	btfss	indic_comptage_termine,1	;***Comptage moteur 10
	call	Comptage_capt_mot10

	btfss	indic_comptage_termine,0
	goto	test_mot9
	goto	fin_test_mot9

test_mot9
	
	movlw	0X07F
	bcf	STATUS,Z
	bcf	STATUS,C
	subwf	Compter_9_Octet_low,W

	btfsc	STATUS,Z
	call	test_fin_comptage_mot9

fin_test_mot9

	btfss	indic_comptage_termine,1
	goto	test_mot10
	goto	fin_test_mot10

test_mot10
	movlw	0X07F
	bcf	STATUS,Z
	bcf	STATUS,C
	subwf	Compter_10_Octet_low,W

	btfsc	STATUS,Z
	call	test_fin_comptage_mot10

fin_test_mot10

	movlw	B'00000011'
	bcf	STATUS,Z
	subwf	indic_comptage_termine,W

	btfss	STATUS,Z
	goto	bcle_comptage_capt

	return

Comptage_capt_mot9

	;*** RB1 ======> entre du comptage
	btfsc	PORTB,1			;*** Commande Moteur 9 
	call	sortie_rb1_a_1	

	btfss	PORTB,1			;*** Commande Moteur 9
	call	sortie_rb1_a_0	

	return

Comptage_capt_mot10
	;*** RB0 ======> entre du comptage
	btfsc	PORTB,0		;*** Commande Moteur 10
	call	sortie_rb0_a_1	

	btfss	PORTB,0		;*** Commande Moteur 10
	call	sortie_rb0_a_0
	return


test_fin_comptage_mot9
	decfsz	Compter_9_Octet_high,F
	goto	Reinit_octet_mot9_low	

	call	fin_comptage_capt_mot9
fin_test_fin_comptage_mot9

	return

fin_comptage_capt_mot9
	;*** Compter_9_Octet_low: Octet de poids faible
	clrf	Compter_9_Octet_low
bcle_comptage_mot9_low

	Call Comptage_capt_mot9

	movf	compter_capt2,W
	bcf	STATUS,Z
	bcf	STATUS,C
	subwf	Compter_9_Octet_low,W

	btfss	STATUS,Z
	goto	bcle_comptage_mot9_low

	bsf	indic_comptage_termine,0

	return



test_fin_comptage_mot10
	decfsz	Compter_10_Octet_high,F
	goto	Reinit_octet_mot10_low	

	call	fin_comptage_capt_mot10
fin_test_fin_comptage_mot10
	return

fin_comptage_capt_mot10
	;*** Compter_10_Octet_low: Octet de poids faible
	clrf	Compter_10_Octet_low
bcle_comptage_mot10_low
	call	Comptage_capt_mot10

	movf	compter_capt2,W
	bcf	STATUS,Z
	bcf	STATUS,C
	subwf	Compter_10_Octet_low,W

	btfss	STATUS,Z
	goto	bcle_comptage_mot10_low

	bsf	indic_comptage_termine,1

	return

Reinit_octet_mot9_low
	clrf Compter_9_Octet_low
	goto fin_test_fin_comptage_mot9

Reinit_octet_mot10_low
	clrf Compter_10_Octet_low
	goto fin_test_fin_comptage_mot10

sortie_rb1_a_1

	btfss	mem_etat_broche_B1,0
	incf	Compter_par_pas_9,F

	movf	pas_incremental,W
	bcf	STATUS,Z
	subwf	Compter_par_pas_9,W

	btfsc STATUS,Z
	incf	Compter_9_Octet_low,F

	btfsc	STATUS,Z
	clrf	Compter_par_pas_9

	btfss	mem_etat_broche_B1,0
	incf	comptage_roue_droite_low,F

	;*** comptage global
	movlw	0X07F
	bcf	STATUS,Z
	subwf	comptage_roue_droite_low,W

	btfsc	STATUS,Z
	incf	comptage_roue_droite_high,F

	btfsc	STATUS,Z
	clrf	comptage_roue_droite_low

	bsf	mem_etat_broche_B1,0

	return

sortie_rb1_a_0

;	btfsc	mem_etat_broche_B1,0
;	incf	Compter_9_Octet_low,F

;	btfsc	mem_etat_broche_B1,0
;	incf	comptage_roue_droite_low,F

;	;*** comptage global
;	movlw	0X07F
;	bcf	STATUS,Z
;	subwf	comptage_roue_droite_low,W

;	btfsc	STATUS,Z
;	incf	comptage_roue_droite_high,F

;	btfsc	STATUS,Z
;	clrf	comptage_roue_droite_low

	bcf	mem_etat_broche_B1,0
	return


sortie_rb0_a_1

	btfss	mem_etat_broche_B0,0
	incf	Compter_par_pas_10,F

	movf	pas_incremental,W
	bcf	STATUS,Z
	subwf	Compter_par_pas_10,W

	btfsc STATUS,Z
	incf	Compter_10_Octet_low,F

	btfsc	STATUS,Z
	clrf	Compter_par_pas_10

	btfss	mem_etat_broche_B0,0
	incf	comptage_roue_gauche_low,F

	;*** comptage global
	movlw	0X07F
	bcf	STATUS,Z
	subwf	comptage_roue_gauche_low,W

	btfsc	STATUS,Z
	incf	comptage_roue_gauche_high,F

	btfsc	STATUS,Z
	clrf	comptage_roue_gauche_low

	bsf	mem_etat_broche_B0,0
	return

sortie_rb0_a_0

;	btfsc	mem_etat_broche_B0,0
;	incf	Compter_10_Octet_low,F
;
;	btfsc	mem_etat_broche_B0,0
;	incf	comptage_roue_gauche_low,F
;
;	;*** comptage global
;	movlw	0X07F
;	bcf	STATUS,Z
;	subwf	comptage_roue_gauche_low,W
;
;	btfsc	STATUS,Z
;	incf	comptage_roue_gauche_high,F
;
;	btfsc	STATUS,Z
;	clrf	comptage_roue_gauche_low
;
	bcf	mem_etat_broche_B0,0
	return

	;***********************************
	;*** Diffrence entre les 2 capteurs
	;***********************************
difference_trop_grande

	;*** calcul diffrence moteur 9 - moteur 10 sur les  octets de poids fort
	movf comptage_roue_droite_high,W
	bcf STATUS,Z
	bcf STATUS,C
	Subwf comptage_roue_gauche_high,W	;*** es 10-es 9, rsultat dans w.

	btfsc STATUS,Z
	goto difference_low

	btfsc STATUS,C
	goto taille_difference_positive

	goto taille_difference_negative

;	bsf PORTB,2
;	btfsc STATUS,C
;	bcf PORTB,3
	
;	bcf PORTB,2
;	btfss STATUS,C
;	bsf PORTB,3

fin_difference_trop_grande

	return



taille_difference_positive
	bcf STATUS,Z
	sublw	0X0C8
	btfsc	STATUS,C
	bsf PORTB,2
	btfsc	STATUS,C
	bcf PORTB,3
	
	goto	fin_difference_trop_grande
	return

taille_difference_negative
	;*** soustraction ensens inverse
	movf comptage_roue_gauche_high,W
	bcf STATUS,Z
	bcf STATUS,C
	Subwf comptage_roue_droite_high,W	;*** es 10-es 9, rsultat dans w.
	bcf STATUS,Z
	sublw	0X0C8
	btfsc	STATUS,C
	bcf PORTB,2
	btfsc	STATUS,C
	bsf PORTB,3
	goto	fin_difference_trop_grande

	
difference_low
	movf comptage_roue_droite_low,W
	bcf STATUS,Z
	bcf STATUS,C
	Subwf comptage_roue_gauche_low,W	;*** es 10-es 9, rsultat dans w.

	btfsc STATUS,Z
	bcf PORTB,2
	btfsc STATUS,Z
	bcf PORTB,3
	btfsc STATUS,Z
	goto fin_difference_trop_grande

	btfsc STATUS,C
	bsf PORTB,2
	btfsc STATUS,C
	bcf PORTB,3

	btfss STATUS,C
	bcf PORTB,2
	btfsc STATUS,C
	bsf PORTB,3

	goto fin_difference_trop_grande


	;*** Tempo 500 S
DELAY500
    MOVLW       0x0A5              ; +1        1 cycle
    MOVWF       DELAY               ; +2        1 cycle
DELAY500_LOOP
    DECFSZ      DELAY, F            ; step1     1 cycle
    GOTO        DELAY500_LOOP       ; step2     2 cycles
DELAY500_END
    RETURN                          ; +3        2 cycles


ENVOI_FIN_ASSERVISSEMENT
	bsf	PORTB,4	
	bsf PORTB,6
	;*** attend x ms
	MOVLW 	    0X07F
	MOVWF       X_DELAY             ; +1        1 cycle
X_DELAY500_LOOP
	CALL        DELAY500            ; step1     wait 500uSec
	DECFSZ      X_DELAY, F          ; step2     1 cycle
	GOTO        X_DELAY500_LOOP     ; step3     2 cycles

	MOVLW 0X07F
	MOVWF       X_DELAY             ; +1        1 cycle
X_DELAY500_LOOP2
	CALL        DELAY500            ; step1     wait 500uSec
	DECFSZ      X_DELAY, F          ; step2     1 cycle
	GOTO        X_DELAY500_LOOP2     ; step3     2 cycles

	bcf PORTB,4
	bcf PORTB,6
;*** boucle


	movf	comptage_roue_droite_low,W
	movwf	NumBaliseDetecte
	call ENVOI_PICBASIC

	movf	comptage_roue_droite_high,W
	movwf	NumBaliseDetecte
	call ENVOI_PICBASIC

	movf	comptage_roue_gauche_low,W
	movwf	NumBaliseDetecte
	call ENVOI_PICBASIC

	movf	comptage_roue_gauche_high,W
	movwf	NumBaliseDetecte
	call ENVOI_PICBASIC

	clrf comptage_roue_droite_low
	clrf comptage_roue_droite_high

	clrf comptage_roue_gauche_low
	clrf comptage_roue_gauche_high

	clrf	indic_comptage_termine	
	clrf	mem_etat_broche_B1	;*** bit 1: mmorisation de l'tat du port B 1 l'instant d'avant, bit 2: utilis pour stocker la CARRY et bit 3: Le Z de la fonction difference_trop_grande.
	clrf	compteur_B1		
	clrf	mem_etat_broche_B0	
	clrf	compteur_B0
	clrf	memo_depassement

	return

test_debug
	movlw	0X07F
	bcf	STATUS,Z
	subwf	comptage_roue_droite_high,W
	btfsc	STATUS,Z
	bsf	PORTB,4

	btfss	STATUS,Z
	bcf	PORTB,4

	return
	
	
