;************************************
;*** recup des infos issus de gp2d02
;************************************

;***************************************************************************
;***************************************************************************
;*** 			DONNEES : 					 ***
;***************************************************************************
;*** signal clock des tlmtrex (broches Vin gp2d02) ===> PORTB, 5	 ***
;*** signal donnes tlmtre 1 (broche vin de GP2D02 n1) ===> PORTB,0	 ***
;*** signal donnes tlmtre 2 (broche vin de GP2D02 n2) ===> PORTB,1	 ***
;*** signal donnes tlmtre 3 (broche vin de GP2D02 n3) ===> PORTA,3	 ***
;***************************************************************************
;***************************************************************************



;****************************
;*** FONCTIONS GENERALES ****
;****************************

telemetre_1
	Call	communication_OK
	bsf	PORTB,4	;DDDDDDEEEEEEEEEEEBBBBBBBUUUUUUGGGGGGGG!!!!!!!!!!!!!!!!
	call	gp2d02_1
	movf	CURRENT,W
	call	ENVOI_PICBASIC
	bcf	PORTB,4	;DDDDDDEEEEEEEEEEEBBBBBBBUUUUUUGGGGGGGG!!!!!!!!!!!!!!!!
	return

telemetre_2
	Call	communication_OK
	bsf	PORTB,4	;DDDDDDEEEEEEEEEEEBBBBBBBUUUUUUGGGGGGGG!!!!!!!!!!!!!!!!
	call	gp2d02_2
	movf	CURRENT,W
	call	ENVOI_PICBASIC
	bcf	PORTB,4	;DDDDDDEEEEEEEEEEEBBBBBBBUUUUUUGGGGGGGG!!!!!!!!!!!!!!!!
	return	
	
telemetre_3
	Call	communication_OK
	bsf	PORTB,4	;DDDDDDEEEEEEEEEEEBBBBBBBUUUUUUGGGGGGGG!!!!!!!!!!!!!!!!
	call	gp2d02_3
	movf	CURRENT,W
	call	ENVOI_PICBASIC
	bcf	PORTB,4	;DDDDDDEEEEEEEEEEEBBBBBBBUUUUUUGGGGGGGG!!!!!!!!!!!!!!!!
	return	

tous_les_telemetres
	Call	communication_OK
	bsf	PORTB,4	;DDDDDDEEEEEEEEEEEBBBBBBBUUUUUUGGGGGGGG!!!!!!!!!!!!!!!!

	bcf	PORTB, 5	; active le dtecteur
	nop

wait_for_reading_tous
	btfss	PORTB, 0	; attend
	goto	wait_for_reading_tous	; que le dtecteur 1 ait fait la mesure
	btfss	PORTB, 1	; attend
	goto	wait_for_reading_tous	; que le dtecteur 2 ait fait la mesure
	btfss	PORTA,3		; attend
	goto	wait_for_reading_tous	; que le dtecteur 3 ait fait la mesure

	bsf	PORTB, 5	; demande la valeur
				; aux dtecteurs

	clrf	CURRENT_Detecteur1		; RAZ de l'ancienne valeur de dtection tlmtre 1
	clrf	CURRENT_Detecteur2		; RAZ de l'ancienne valeur de dtection tlmtre 1
	clrf	CURRENT_Detecteur3		; RAZ de l'ancienne valeur de dtection tlmtre 1

	movlw	8		; RAZ pour l'horloge
	movwf	BITCOUNT

	bcf	STATUS, C	; bit de retenue  0 pour la rotation de bits.

	nop			; impulsion d'horloge

read_bit_tous
	bcf	PORTB, 5	; horloge au niveau bas

	nop			; impulsion d'horloge
	nop

	rlf	CURRENT_Detecteur1, f	; "avance" le bit prcedent pour le tlmtre 1
	rlf	CURRENT_Detecteur2, f	; "avance" le bit prcedent pour le tlmtre 2
	rlf	CURRENT_Detecteur3, f	; "avance" le bit prcedent pour le tlmtre 3

	btfsc	PORTB, 0	; rcupration du bit en sortie du gp2d02 n1
	bsf	CURRENT_Detecteur1, 0	; si bit en sortie  1 => met  1 CURRENT_Detecteur1

	btfsc	PORTB, 1	; rcupration du bit en sortie du gp2d02 n2
	bsf	CURRENT_Detecteur2, 0	; si bit en sortie  1 => met  1 CURRENT_Detecteur2

	btfsc	PORTA, 3	; rcupration du bit en sortie du gp2d02 n3
	bsf	CURRENT_Detecteur3, 0	; si bit en sortie  1 => met  1 CURRENT_Detecteur3


	bsf	PORTB, 5	; Front montant de l'horloge

	nop			; temps d'horloge
	nop

	decfsz	BITCOUNT, f	; Les 8 bits sont rcuprs?
	goto read_bit_tous	; non: rcuprer les autres bits

	movf	CURRENT_Detecteur1,W	; acquisition termine:envoi des donnes du dtecteur 1
	call	ENVOI_PICBASIC

	movf	CURRENT_Detecteur2,W	; acquisition termine:envoi des donnes du dtecteur 2
	call	ENVOI_PICBASIC

	movf	CURRENT_Detecteur3,W	; acquisition termine:envoi des donnes du dtecteur 3
	call	ENVOI_PICBASIC


	bcf	PORTB,4	;DDDDDDEEEEEEEEEEEBBBBBBBUUUUUUGGGGGGGG!!!!!!!!!!!!!!!!
	return

;************************
;*** FONCTIONS GP2D02 ***
;************************

;*********************************
;*** recup donnes tlmtre 1 ***
;*********************************

gp2d02_1
	bcf	PORTB, 5	; active le dtecteur
	nop

wait_for_reading_gp2D02_1
	btfss	PORTB, 0	; attend
	goto	wait_for_reading_gp2D02_1	; que le dtecteur ait fait la mesure

	bsf	PORTB, 5	; demande la valeur
				; au dtecteur

	clrf	CURRENT		; RAZ de l'ancienne valeur de dtection

	movlw	8		; RAZ pour l'horloge
	movwf	BITCOUNT	; des donnes en sortie

	bcf	STATUS, C	; bit de retenue  0 pour la rotation de bits.

	nop			; impulsion d'horloge

read_bit_gp2d02_1
	bcf	PORTB, 5	; horloge au niveau bas

	nop			; impulsion d'horloge
	nop

	rlf	CURRENT, f	; "avance" le bit prcedent

	btfsc	PORTB, 0	; rcupration du bit en sortie du gp2d02
	bsf	CURRENT, 0	; si bit en sortie  1 => met  1 CURRENT

	bsf	PORTB, 5	; Front montant de l'horloge

	nop			; temps d'horloge
	nop

	decfsz	BITCOUNT, f	; Les 8 bits sont rcuprs?
	goto read_bit_gp2d02_1	; non: rcuprer les autres bits

	movf	CURRENT,W	; oui: retourne la valeur rcupre

	return


;*********************************
;*** recup donnes tlmtre 2 ***
;*********************************

gp2d02_2
	bcf	PORTB, 5	; active le dtecteur
	nop

wait_gp2D02_2
	btfss	PORTB, 1	; attend
	goto wait_gp2D02_2	; que le dtecteur ait fait la mesure

	bsf	PORTB, 5	; demande la valeur
				; au dtecteur

	clrf	CURRENT		; RAZ de l'ancienne valeur de dtection

	movlw	8		; RAZ pour l'horloge
	movwf	BITCOUNT	; des donnes en sortie

	bcf	STATUS, C	; bit de retenue  0 pour la rotation de bits.

	nop			; impulsion d'horloge
	nop			; impulsion d'horloge
	nop			; impulsion d'horloge

read_bit_2
	bcf	PORTB, 5	; horloge au niveau bas

	nop			; impulsion d'horloge
	nop
	nop			; impulsion d'horloge
	nop			; impulsion d'horloge

	rlf	CURRENT, f	; "avance" le bit prcedent

	btfsc	PORTB, 1	; rcupration du bit en sortie du gp2d02
	bsf	CURRENT, 0	; si bit en sortie  1 => met  1 CURRENT

	bsf	PORTB, 5	; Front montant de l'horloge

	nop			; temps d'horloge
	nop
	nop			; impulsion d'horloge
	nop			; impulsion d'horloge

	decfsz	BITCOUNT, f	; Les 8 bits sont rcuprs?
	goto read_bit_2		; non: rcuprer les autres bits

	movf	CURRENT,W	; oui: retourne la valeur rcupre

	return


;*********************************
;*** recup donnes tlmtre 3 ***
;*********************************

gp2d02_3	
	bcf	PORTB,5		; active le dtecteur
	nop

wait_for_reading_gp2D02_3
	btfss	PORTA,3		; attend
	goto wait_for_reading_gp2D02_3	; que le dtecteur ait fait la mesure

	bsf	PORTB,5		; demande la valeur
					; au dtecteur

	clrf	CURRENT		; RAZ de l'ancienne valeur de dtection

	movlw	8		; RAZ pour l'horloge
	movwf	BITCOUNT	; des donnes en sortie

	bcf	STATUS, C	; bit de retenue  0 pour la rotation de bits.

	nop			; impulsion d'horloge
	nop			; impulsion d'horloge
	nop			; impulsion d'horloge

read_bit_gp2d02_3
	bcf	PORTB, 5	; horloge au niveau bas

	nop			; impulsion d'horloge
	nop
	nop			; impulsion d'horloge
	nop			; impulsion d'horloge

	rlf	CURRENT, f	; "avance" le bit prcedent

	btfsc	PORTA,3		; rcupration du bit en sortie du gp2d02
	bsf	CURRENT, 0	; si bit en sortie  1 => met  1 CURRENT

	bsf	PORTB,5		; Front montant de l'horloge

	nop			; temps d'horloge
	nop
	nop			; impulsion d'horloge
	nop			; impulsion d'horloge

	decfsz	BITCOUNT, f	; Les 8 bits sont rcuprs?
	goto read_bit_gp2d02_3	; non: rcuprer les autres bits

	movf	CURRENT,W		; oui: retourne la valeur rcupre

	return
