;********************************************************************
;*** commande de l'asservissement des moteurs liaison I2C "maison"
;********************************************************************
	
	list    p=16f84
	#include<p16f84.inc>

;***************************************************************************************
;*** Declaration des variables
;***************************************************************************************

;*** DESCRIPTION DES BROCHES ***
;*** PORTA,0 : rception des infos PICBASIC (infos du PICBASIC vers la carte PICATF) ==> IO 18 Du PICBASIC
;*** PORTA,1 : ? non utilis ?
;***		pourrait tre utilis pour un 4eme tlmtre
;*** PORTA,2 : ? non utilis ?
;***		pourrait tre utilis pour un 5eme tlmtre
;*** PORTA,3 : entre Tlmtre 3 (vout du gp2d02)
;*** PORTA,4 : entre balise
;*** PORTB,0 : entre Tlmtre 1 (vout du gp2d02)
;*** PORTB,1 : entre Tlmtre 2 (vout du gp2d02)
;*** PORTB,2 : vers PICBASIC (anciennement in de l'asservissement moteurs coupe 2002)
;*** PORTB,3 : vers PICBASIC (anciennement in de l'asservissement moteurs coupe 2002)
;*** PORTB,4 : DEBUG
;*** PORTB,5 : Anciennement utilis (cpe2002) pour gnrer une interruption sur le picbasic (a verifier!)
;***		utilis pour gnrer le signal d'horloge du tlmtre
;*** PORTB,6 : DATA du picatf vers le picbasic ==> IO 27 du PICBASIC
;*** PORTB,7 : CLOCK PICBASIC ==> IO 26 du PICBASIC


;*** DESCRIPTION DES FICHIERS ***
;*** initio.asm : initialisation des E/S du PIC
;*** initvara.asm : declaration/initialisation des variables du PIC
;*** recois.asm : recois les infos via IC envoyes par le PICBASIC
;*** envoi.asm : envoi des infos via IC au PICBASIC
;*** balise.asm : rception des infos de la balise
;*** gp2d02.asm : rception des infos des gp2d02


	org 0x000
	goto MAIN

	#include<initio.asm>
	#include<initvara.asm>
	#include<recois.asm>
	#include<envoi.asm>
	#include<balise.asm>
	#include<gp2d02.asm>
	#include<tempo.asm>


MAIN

	call	init_vara
	call	INITIO
BOUCLE
	call	init_vara
	;*** rception de l'action  faire
	call reception_infos_picbasic
	
	;*** sauvegarde la variable de rception dans code_action
	movf vrec,W
	movwf code_action

;	DEBUG !!!!!!!!
;test_val_recue
;	nop
;	bcf	PORTB,4
;	nop
;	bsf	PORTB,4
;	decfsz	vrec,F
;	goto 	test_val_recue
;	FIN DEBUG !!!!!!!!

	clrf	Temp
	;*** si code 10 : Balise
	movf	code_action,W
	bcf	STATUS,Z	
	sublw	0X00A
	btfsc	STATUS,Z
	call	Mode_Detection_Balise	
	
	;*** si code 11 : tlmtre N1
	movf 	code_action,W
	bcf 	STATUS,Z
	sublw 	0X00B
	btfsc 	STATUS,Z
	call 	telemetre_1
	
	;*** si code 12 : tlmtre N2
	movf code_action,W
	bcf 	STATUS,Z
	sublw 	0X00C
	btfsc	STATUS,Z
	call	telemetre_2
	
	;*** si code 13 : tlmtre N3
	movf	code_action,W
	bcf	STATUS,Z
	sublw	0X00D
	btfsc	STATUS,Z
	call	telemetre_3

	;*** si code 14 : tous les tlmtres
	movf	code_action,W
	bcf	STATUS,Z
	sublw	0X00E
	btfsc	STATUS,Z
	call	tous_les_telemetres	

	;*** Si la valeur rcupre n'est pas bonne, alors on envoie une erreur
	btfss	Temp,0
	call	erreur_communication
		
	GOTO 	BOUCLE

erreur_communication
	movlw	0x0FF
	call	ENVOI_PICBASIC
	movlw	0x0FF
	call	ENVOI_PICBASIC
	return

communication_OK
	bsf	Temp,0
;	movf	code_action,W
	movlw	0X010
	call	ENVOI_PICBASIC
;	movf	code_action,W
	movlw	0X010
	call	ENVOI_PICBASIC
	return


	END



